Option explicit
Option base 1


Mode 1,12
'Mode 3,12
'Mode 3,8
CLS

Dim xSize=16
Dim ySize=16

Dim header$="16,1,16"
Dim fileName$="output.spr"

Dim xOffset=5
Dim yOffset=1

Dim xImage=200
Dim yImage=20

Dim bgColour=RGB(64,64,64)
Dim imageBorder=4

Dim xMag=200
Dim yMag=50
Dim mag=4

Dim sBlank$="................"
Dim fBlank$="                "

'screen representation
Dim s$(ySize)

'file representation
Dim f$(ySize)

Dim y,x
For y=1 to ySize
  s$(y)=sBlank$
  f$(y)=fBlank$
Next

Sub LocateEntry x,y
  LocateCell x+xOffset,y+yOffset
End sub

For y=1 to ySize
  For x=1 to xSize
    LocateEntry x,y
    Print mid$(s$(y),x,1);
'    Print ".";
  Next x
  'Print s$(y)
Next
Print
Print
Print "Controls: ZXOK or arrows to move, space to clear, 0-7 to set colour"
Print "S to save and display. Warning, will overwrite previous save"
Print "Capital-L to load and display. Editing loaded files not yet supported"
Print "File name: ";fileName$
Print "Q to quit"

dim cursorX,cursorY

Sub SaveSprite
  cursorX=x:cursorY=y
  'Print "Please wait until finished..."
  Open fileName$ for output as #1
  Print #1, header$
  For y=1 to ySize
    Print #1, f$(y)
  Next
  Close #1
  'Print "Done"
  Sprite load fileName$,1


  Box xImage - imageBorder,yImage - imageBorder, xSize + 2*imageBorder, ySize+2*imageBorder, 0,bgColour,bgColour


  Sprite show 1, xImage, yImage,1
  Image resize_fast xImage, yImage, xSize, ySize, xMag, yMag, mag * xSize, mag * ySize

  Sprite close all
  Pause 500

  x=cursorX:y=cursorY

End sub

Sub LoadScreenColour scrColour, c
  cursorX=x:cursorY=y

  Pixel xImage,yImage,c
  scrColour = pixel(xImage,yImage)
End sub

Sub LoadSprite
  Local scBG,ScBlack,ScBlue,ScGreen,ScCyan,ScRed,ScMagenta,ScYellow,scWhite

  LoadScreenColour scBG, bgColour
  LoadScreenColour scBlack, RGB(black)

  scBlack=scBlack OR &hF000000

  LoadScreenColour scBlue, RGB(blue)
  LoadScreenColour scGreen, RGB(green)
  LoadScreenColour scCyan, RGB(cyan)
  LoadScreenColour scRed, RGB(red)
  LoadScreenColour scMagenta, RGB(magenta)
  LoadScreenColour scYellow, RGB(yellow)
  LoadScreenColour scWhite, RGB(white)

  'pixel xImage,yImage,RGB(Red)
  'scRed = pixel(xImage,yImage)

  Sprite load fileName$,1

  Box xImage - imageBorder,yImage - imageBorder, xSize + 2*imageBorder, ySize+2*imageBorder, 0,bgColour,bgColour

  Sprite show 1, xImage, yImage,1
  Image resize_fast xImage, yImage, xSize, ySize, xMag, yMag, mag * xSize, mag * ySize

  Sprite close all

  Local p, ps$, pf$

  For y=1 to ySize
    For x=1 to xSize
      p=pixel( (x-1) + xImage, (y-1) + yImage )
      select case p 'or &hff000000 ' don't include alpha channel
        case scBG
          'ps$="."
          pf$=" "
        case scBlack
          pf$="0"
        case scBlue
          pf$="1"
        case scGreen
          pf$="2"
        case scCyan
          pf$="3"
        case scRed
          pf$="4"
        case scMagenta
          pf$="5"
        case scYellow
          pf$="6"
        case scWhite
          pf$="7"
        case else
          'ps$=""
          pf$="?"
      print @(0,400) hex$(p);"  ";hex$(scblack);" "
      end select
      select case pf$
        case " "
          ps$="."
        case else
          ps$=pf$
      end select
'      print @(0,400) hex$(p);"  ";hex$(scbg);" "
'      print @(0,400) hex$(p);"  ";hex$(bgcolour);" "
      Mid$(s$(y),x,1)=ps$
      Mid$(f$(y),x,1)=pf$
   
      LocateEntry x,y
      Print mid$(s$(y),x,1);
    Next x
  Next

  x=cursorX:y=cursorY
  
End sub

x=1
y=1


Dim c$
Do
  LocateEntry x,y
  Print "C"
  Pause 50
  c$=inkey$
  LocateEntry x,y
  Print mid$(s$(y),x,1);    
  Select case c$
    Case "z","Z",chr$(130)
      x=x-1
    Case "x","X",chr$(131)
      x=x+1
    Case "o","O",chr$(128)
      y=y-1
    Case "k","K",chr$(129)
      y=y+1
    Case "q","Q"
quit: End
    Case " "
      Mid$(s$(y),x,1)="."
      Mid$(f$(y),x,1)=" "
    Case "0" to "7"
      Mid$(s$(y),x,1)=c$
      Mid$(f$(y),x,1)=c$
    Case "S","s"
      SaveSprite
    Case "L"
      'requires pressing shift/capslock, so you don't accidentally load over your work
      LoadSprite
  End select
  x=min(x,xSize)
  x=max(x,1)
  y=min(y,ySize)
  y=max(y,1)
Loop



input y

Sub LocateCell x,y
  Print @(x*MM.Info(FontWidth),y*MM.Info(FontHeight));
  'I tried without a semicolon and it didn't work right.
End Sub


